--- init_menus.c	2001-02-03 15:19:40.000000000 -0500
+++ init_menus.c	2014-12-26 01:58:48.000000000 -0500
@@ -40,5 +40,7 @@
 
 #include <stdio.h>
+#include <string.h>
 #include <X11/Xlib.h>
+#include <X11/Xresource.h>
 #include <X11/Xutil.h>
 
@@ -60,8 +62,8 @@ int menus_color = True;
 static ResourcesMenu	rm;
 
-FCT (static int, getnbstr, (char **tstr) );
-FCT (static char *, getmaxstr, (char **tstr) );
+FCT (static int, getnbstr, (const char **tstr) );
+FCT (static const char *, getmaxstr, (const char **tstr) );
 FCT (static void, show_bar, (Display *display, Window w, XYMenu *menu) );
-FCT (static VMenu *, Vmenu, (Display *display, Window window,XYMenu *menu, char **item, int x_title, void (**fnt) (), unsigned long bg) );
+FCT (static VMenu *, Vmenu, (Display *display, Window window,XYMenu *menu, const char **item, int x_title, void (**fnt) (), unsigned long bg) );
 
 /*
@@ -150,6 +152,6 @@ XYMenu *MakeMenus ( display, w, title, i
     Display		*display;
     Window		w;
-    char		**title;
-    char		***item;
+    const char		**title;
+    const char		***item;
     void		(**fnt []) ();
 {
@@ -158,10 +160,10 @@ XYMenu *MakeMenus ( display, w, title, i
   XWindowAttributes att;
   int i = 0;
-  int x, width;
-  VMenu	*Vmenu ();
-  
+  int x;
+  intptr_t width;
+
   XGetWindowAttributes ( display, w, &att );
-  menu = ( XYMenu * ) malloc ( sizeof ( XYMenu ));
-  bzero ( (char *) menu, sizeof ( XYMenu ));
+  menu = malloc (sizeof (XYMenu));
+  bzero (menu, sizeof(XYMenu));
   
   menu -> width_relief = DEPTH_WIDTH;
@@ -200,5 +202,5 @@ XYMenu *MakeMenus ( display, w, title, i
   while ( *title != 0 ) {
     width = XTextWidth ( rm.font, *title, strlen ( *title )) + 20;
-    *title++;	
+    title++;	
     menu->w_title [i] =
       XCreateSimpleWindow ( display, menu->w_bar, x, 2,
@@ -228,6 +230,6 @@ XYMenu *MakeMenus ( display, w, title, i
     x += width;
     i++;
-    *item++;
-    *fnt++;
+    item++;
+    fnt++;
     if ( i > 10 )
       break;
@@ -264,42 +266,4 @@ int MouseInMenuBar ( display, w )
 
 /*
-**	Function name : SetMenuPixmap
-**
-**	Description : Fabrication d'un pixmap pour sauvegarder
-**		les parties cachees.
-**	Input : Le display, le menu, largeur de la fenetre parent.
-**	Ouput :
-*/
-void SetMenuPixmap ( display, menu, width )
-    Display *display;
-    XYMenu *menu;
-    int width;
-{
-/*  
-  if ( menu -> save != 0 ) {
-#ifdef DEBUG
-    fprintf ( stderr, "Pixmap ms = %d\n", menu -> save );
-#endif
-    XFreePixmap ( display, menu -> save );
-  }
-  
-#ifdef SHADOW
-  menu -> save = XCreatePixmap ( display,
-				menu -> w_under, width,
-				menu -> hmax_menu + SHAD + 10,
-				DefaultDepth ( display, DefaultScreen ( display )));
-#else
-  menu -> save = XCreatePixmap ( display,
-				menu -> w_under , width,
-				menu -> hmax_menu + 10,
-				DefaultDepth ( display, DefaultScreen ( display )));
-#endif
-  menu -> save_ok = 0;
-  menu -> pix_width = width;
-*/
-}
-
-
-/*
 **	Function name : Vmenu
 **
@@ -315,5 +279,5 @@ static VMenu *Vmenu ( display, window, m
     Window	window;
     XYMenu	*menu;
-    char **item;
+    const char **item;
     int x_title;
     void (**fnt) ();
@@ -322,12 +286,11 @@ static VMenu *Vmenu ( display, window, m
   VMenu	*vm;
   SWindow	*sw;
-  char	*getmaxstr ();
   XSetWindowAttributes att, att_io;
   int x_menu, n;
-  char *maxstr;
+  const char *maxstr;
   int nb_item;
   
-  vm = ( VMenu * ) malloc ( sizeof ( VMenu ));
-  bzero ( (char *) vm, sizeof ( VMenu ));
+  vm = malloc(sizeof(VMenu));
+  bzero (vm, sizeof (VMenu));
   maxstr = getmaxstr ( item );
   nb_item = getnbstr ( item );
@@ -391,6 +354,6 @@ static VMenu *Vmenu ( display, window, m
     vm -> func [n] = *fnt;
     n++;
-    *item++;
-    *fnt++;
+    item++;
+    fnt++;
   }
 #ifdef SHADOW
@@ -432,10 +395,10 @@ void SetHiddenWindow ( menu, w, gc )
 */
 static int getnbstr ( tstr )
-    char **tstr;
+    const char **tstr;
 {
   int i = 0;
   while ( *tstr != 0 ) {
     i++;
-    *tstr++;
+    tstr++;
     if ( i > 100 ) return ( 0 );
   }
@@ -453,8 +416,8 @@ static int getnbstr ( tstr )
 **	Ouput : La plus grande chaine.
 */
-static char *getmaxstr ( tstr )
-    char **tstr;
+static const char *getmaxstr ( tstr )
+    const char **tstr;
 {
-  char *s;
+  const char *s;
   int i, j;
   
@@ -485,5 +448,5 @@ void RefreshMenuBar ( display, menu )
 {
   int i;
-  char 	**str = menu->titlename;
+  const char 	**str = menu->titlename;
   
   XResizeWindow ( display, menu -> w_bar, menu -> bar_width,
--- init_menus.h	1995-02-22 08:03:33.000000000 -0500
+++ init_menus.h	2014-12-26 01:58:36.000000000 -0500
@@ -92,5 +92,5 @@ typedef struct _VMenu {
 	void (*func [MAX_ITEMS])();		/* Les callbacks */
 	int nb_items;			/* Le nombre d'items */
-	char **iname;	/* Les chaines de caracteres associes */
+	const char **iname;	/* Les chaines de caracteres associes */
 	int x;		/* Position horizontale des menus */
 	int width, height;	/* Largeur et hauteur */
@@ -129,6 +129,6 @@ typedef struct _XYMenu {
 	int nb_menus;	/* Le nombre de menus */
 	VMenu *vmenu [MAX_MENUS];	/* Les menus verticaux */
-	char **titlename;	/* Les noms des menus */
-	char ***itemname;	/* Les noms des items */
+	const char **titlename;	/* Les noms des menus */
+	const char ***itemname;	/* Les noms des items */
 	int (***f_item) ();	/* Les callbacks associees */
 	unsigned int y_menu;	/* Position par rapport au parent */
@@ -154,9 +154,8 @@ FCT (int, ButtonPressInMenu, (Window w, 
 FCT (void, DeleteMenu, (Display *display, XYMenu *menu) );
 FCT (void, InitMenusRes, (Display *display, XFontStruct	*font,unsigned long fg, unsigned long bg, unsigned long ts, unsigned long bs) );
-FCT (XYMenu *, MakeMenus, (Display *display, Window w, char **title, char ***item, void	(**fnt []) ()) );
+FCT (XYMenu *, MakeMenus, (Display *display, Window w, const char **title, const char ***item, void	(**fnt []) ()) );
 FCT (int, MouseInMenuBar, (Display *display, Window w) );
 FCT (void, RefreshMenuBar, (Display *display, XYMenu *menu) );
 FCT (void, SetHiddenWindow, (XYMenu *menu, Window w, GC gc) );
-FCT (void, SetMenuPixmap, (Display *display, XYMenu *menu, int width) );
 
 #define SetMenuBarWidth(m, x)	(m -> bar_width = x)
--- input_str.h	1997-03-18 07:14:47.000000000 -0500
+++ input_str.h	2014-12-27 22:33:51.000000000 -0500
@@ -44,18 +44,18 @@
 #include "proto_decl.h"
 
-FCT (char *, GetString, (Text *text, char *prompt, int reply) );
-FCT (void, FillMiniBuffer, (char *str) );
-FCT (void, EmptyMiniBuffer, () );
-FCT (void, InitInputString, () );
-FCT (void, InputStrAbort, () );
-FCT (void, InputStrPrevious, (Text *text) );
-FCT (void, InputStrReturn, (Text *text) );
-FCT (void, InputStrTab, (Text *text) );
-FCT (char *, ExpandTildeName, (char *name) );
-FCT (char *, InputString, (Window parent, Window raise, GC gc, XFontStruct *font, char *prompt, int reply) );
-FCT (void, SetCancelButton, () );
-FCT (void, SetOkButton, () );
+FCT (const char *, GetString, (Text *text, const char *prompt, int reply) );
+FCT (void, FillMiniBuffer, (const char *str) );
+FCT (void, EmptyMiniBuffer, (void) );
+FCT (void, InitInputString, (void) );
+FCT (void, InputStrAbort, (void) );
+FCT (void, InputStrPrevious, (void) );
+FCT (void, InputStrReturn, (void) );
+FCT (void, InputStrTab, (void) );
+FCT (const char *, ExpandTildeName, (const char *name) );
+FCT (const char *, InputString, (Window parent, Window raise, GC gc, XFontStruct *font, const char *prompt, int reply) );
+FCT (void, SetCancelButton, (void) );
+FCT (void, SetOkButton, (void) );
 FCT (void, SetMBcontext, (int cont) );
-FCT (void, InputStrSave, (char *, int) );
+FCT (void, InputStrSave, (const char *, int) );
 extern Text *input_str;
 
--- justify.c	1998-10-12 14:25:23.000000000 -0400
+++ justify.c	2014-12-27 05:23:26.000000000 -0500
@@ -21,4 +21,5 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include <limits.h>
 
@@ -942,8 +943,8 @@ int FillManText(font, width, textbuf, in
   
   {
-    char * smaclib = (char *) getenv ("XCORAL_SMACLIB");
+    char * smaclib = getenv ("XCORAL_SMACLIB");
     
     if (smaclib) {
-      char * filename = (char *) malloc(strlen(smaclib) + 10);
+      char * filename = malloc(strlen(smaclib) + 10);
 
       sprintf(filename, "%s/man.dtex", smaclib);
@@ -954,5 +955,5 @@ int FillManText(font, width, textbuf, in
   
   if (! fpdtex) {
-    char * filename = (char *) malloc(strlen(XCORAL_LIB_DIR) + 10);
+    char * filename = malloc(strlen(XCORAL_LIB_DIR) + 10);
 
     sprintf(filename, "%s/man.dtex", XCORAL_LIB_DIR);
--- kill_buf.c	1998-09-20 13:00:19.000000000 -0400
+++ kill_buf.c	2014-12-26 23:51:09.000000000 -0500
@@ -92,5 +92,5 @@ static kb *AllocKillBuf ()
 */
 void StoreInKillBuf ( s, len, n )
-    char *s;
+    const char *s;
     int len;
     int n;
@@ -147,5 +147,5 @@ void StoreInKillBuf ( s, len, n )
 **	Ouput : La chaine.
 */
-char *RestoreKillBuf ( i, len, dn )
+const char *RestoreKillBuf ( i, len, dn )
     int i;
     int *len; /* Return */
@@ -164,5 +164,5 @@ char *RestoreKillBuf ( i, len, dn )
     *len = tmp -> s_len;
     *dn =  tmp -> s_lines;
-    return ( (char *) tmp -> p );
+    return (tmp->p);
 }
 
--- kill_buf.h	1995-02-22 08:03:35.000000000 -0500
+++ kill_buf.h	2014-12-26 23:49:30.000000000 -0500
@@ -60,6 +60,6 @@ typedef struct _kb {
 
 FCT (void, LoadKillBuffer, (Buf *buf) );
-FCT (char *, RestoreKillBuf, (int i, int *len, int *dn) );
-FCT (void, StoreInKillBuf, (char *s, int len, int n) );
+FCT (const char *, RestoreKillBuf, (int i, int *len, int *dn) );
+FCT (void, StoreInKillBuf, (const char *s, int len, int n) );
 
 #endif /* _KILL_BUF_H_ */
--- list_box.c	2006-11-16 03:56:42.000000000 -0500
+++ list_box.c	2014-12-27 05:16:57.000000000 -0500
@@ -40,4 +40,5 @@
 
 #include <stdio.h>
+#include <stdlib.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -60,4 +61,5 @@
 #include "shadow.h"
 #include "kill_buf.h"
+#include "chars_cmds.h"
 
 extern Display *dpy;
@@ -65,9 +67,7 @@ LBox l_box;
 static  Atom list_del;
 
-FCT (static void, DisplayList, (char *msg) );
-FCT (static void, MapListBox, () );
-FCT (static void, UnmapListBox, () );
-FCT (static void, UpdateSelect, () );
-FCT (static void, UpdateListTitle, () );
+FCT (static void, UnmapListBox, (void) );
+FCT (static void, UpdateSelect, (void) );
+FCT (static void, UpdateListTitle, (void) );
 
 /*
@@ -165,18 +165,4 @@ void InitListBox ()
 
 /*
-**	Function name : MapListBox
-**
-**	Description : 
-**	Input : 
-**	Ouput :
-*/
-static void MapListBox ()
-{
-    XMapSubwindows ( dpy, l_box.frame );
-    XMapSubwindows ( dpy, l_box.ctr );
-    XMapRaised ( dpy, l_box.frame );
-}
-
-/*
 **	Function name : UnmapListBox
 **
@@ -347,6 +333,5 @@ static void UpdateSelect ()
 #define S_DELAY 15000	
 
-char *SelectFromListBox ( msg )
-    char *msg;
+char *SelectFromListBox ()
 {
   XEvent ev;
@@ -354,6 +339,5 @@ char *SelectFromListBox ( msg )
   int result, new_select;
   char *str;
-  
-  (void) DisplayList ( msg );
+
   for (;;) {
     XNextEvent ( dpy, &ev );
@@ -393,5 +377,5 @@ char *SelectFromListBox ( msg )
 	      l_box.select = 0;
 	      (void) UnmapListBox ();
-	      return ( (char *) CurrentTextItem ( l_box.text ) );
+	      return (CurrentTextItem ( l_box.text ) );
 	    }
 	  }
@@ -401,5 +385,5 @@ char *SelectFromListBox ( msg )
 	    if ( new_select ) {
 	      l_box.select = new_select;
-	      str = (char *) CurrentTextItem ( l_box.text );
+	      str = CurrentTextItem ( l_box.text );
 	      if ( str ) {
 		(void) sprintf ( l_box.select_text, "Select : %s", str );
@@ -436,5 +420,5 @@ char *SelectFromListBox ( msg )
 	    l_box.select = 0;
 	    (void) UnmapListBox ();
-	    return ( (char *) CurrentTextItem ( l_box.text ) );
+	    return (CurrentTextItem (l_box.text));
 	  }
 	}
@@ -509,36 +493,4 @@ int DoubleClick ( current_t, p_old_t )
 }
 
-/*
-**	Function name : DisplayList
-**
-**	Description : 
-**	Input : 
-**	Ouput :
-*/
-static void DisplayList ( msg )
-    char *msg;
-{
-    
-    if ( l_box.stat != LB_MAP ) {
-	MapListBox ();
-	WaitForMapped ( l_box.frame, False );
-	l_box.stat = LB_MAP;	
-    }
-    else
-          XMapRaised ( dpy, l_box.frame );
-
-    if ( msg != 0 ) {
-	if ( strlen ( msg ) > (TITLE_SIZE - 2) ) {
-	  (void) strncpy ( l_box.title_text, msg, TITLE_SIZE -1 );
-	  l_box.title_text [TITLE_SIZE] = '\0';
-	}
-	else
-	  (void) strcpy ( l_box.title_text, msg );
-    }
-    (void) UpdateListTitle ();
-    (void) UpdateSelect ();
-    TextCursorOff ( l_box.text );
-    FirstPageAndUpdateScroll ( l_box.text );
-}
 
 /*
@@ -550,5 +502,5 @@ static void DisplayList ( msg )
 */
 void FillList ( str )
-    char *str;
+    const char *str;
 {
     if ( str == 0 )
--- list_box.h	1997-01-24 09:56:33.000000000 -0500
+++ list_box.h	2014-12-27 05:13:21.000000000 -0500
@@ -77,13 +77,13 @@ typedef struct _LBox {
 } LBox;
 
-FCT (void, ClearListBox, () );
+FCT (void, ClearListBox, (void) );
 FCT (void, ConfigListBox, (int width, int height) );
 FCT (int, DoubleClick, (Time current_t, Time * old_t) );
 FCT (int, ExposeListBox, (XEvent *ev) );
-FCT (void, FillList, (char *str) );
-FCT (void, InitListBox, () );
-FCT (void, KillBufferInList, () );
-FCT (void, OpenFilesInListBox, () );
-FCT (char *, SelectFromListBox, (char *msg) );
+FCT (void, FillList, (const char *str) );
+FCT (void, InitListBox, (void) );
+FCT (void, KillBufferInList, (void) );
+FCT (void, OpenFilesInListBox, (void) );
+FCT (char *, SelectFromListBox, (void) );
 
 #endif /* _LIST_BOX_H_ */
--- macros.c	1998-09-20 12:16:05.000000000 -0400
+++ macros.c	2014-12-27 05:24:41.000000000 -0500
@@ -40,4 +40,5 @@
 
 #include <stdio.h>
+#include <string.h>
 #include <X11/Xlib.h>
 #include <X11/Xutil.h>
@@ -180,5 +181,5 @@ void LoadMacro ( text, func, arg, repeat
 	  tmp -> f = (void(*)()) f_impc;
 	  /* previous char */
-	  arg = (void *) ((int) *(text -> buf -> l_cur -1));
+	  arg = (void *) ((intptr_t) *(text -> buf -> l_cur -1));
 	}
 	else
--- macros.h	1995-02-22 08:03:36.000000000 -0500
+++ macros.h	2014-12-27 05:24:57.000000000 -0500
@@ -56,5 +56,5 @@ FCT (void, EndMacro, (Text *text) );
 FCT (int, InsideMacro, (Text *text) );
 FCT (void, LoadMacro, (Text *text, FCT(void, (* func), ()), void * arg, int repeat) );
-FCT (void, ResetMacro, () );
+FCT (void, ResetMacro, (void) );
 FCT (void, RunMacro, (Text *text, int n) );
 FCT (void, DeleteMacro, (Text *text) );
--- main_events.h	1997-03-18 12:12:07.000000000 -0500
+++ main_events.h	2014-12-26 00:03:16.000000000 -0500
@@ -45,22 +45,22 @@
 
 FCT (void, FreezeButtons, (Text *text) );
-FCT (void, FreezeMenus, () );
-FCT (int, IsFreezeMenus, () );
-FCT (void, UnFreezeButtons, () );
-FCT (void, UnFreezeMenus, () );
-FCT (void, HandleButtonPress, () );
-FCT (void, HandleConfigure, () );
-FCT (void, HandleEnter, () );
-FCT (void, HandleExpose, () );
-FCT (void, HandleLeave, () );
-FCT (void, InitEvent, () );
+FCT (void, FreezeMenus, (void) );
+FCT (int, IsFreezeMenus, (void) );
+FCT (void, UnFreezeButtons, (void) );
+FCT (void, UnFreezeMenus, (void) );
+FCT (void, HandleButtonPress, (void) );
+FCT (void, HandleConfigure, (void) );
+FCT (void, HandleEnter, (void) );
+FCT (void, HandleExpose, (void) );
+FCT (void, HandleLeave, (void) );
+FCT (void, InitEvent, (void) );
 FCT (void, ResetFd, (int fd) );
 FCT (void, SetFd, (int fd) );
 FCT (void, WaitButtonRelease, (unsigned int button) );
-FCT (void, WaitForXserver, () );
-FCT (void, WaitForEvent, () );
+FCT (void, WaitForXserver, (void) );
+FCT (void, WaitForEvent, (void) );
 FCT (void, WaitForMapped, (Window win, int istext) );
 FCT (void, WaitForUnMapped, (Window win) );
-FCT (void, HandleSelectionClear, () );
+FCT (void, HandleSelectionClear, (void) );
 FCT (void, PasteSelection, (Text *text) );
 
--- main_text.c	2003-04-22 07:34:08.000000000 -0400
+++ main_text.c	2014-12-27 05:18:53.000000000 -0500
@@ -44,5 +44,5 @@
 #include <sys/types.h>
 #include <sys/time.h>
-#include <signal.h>
+#include <unistd.h>
 
 #if HAVE_STRING_H
@@ -62,4 +62,5 @@
 #include "xcoral.h"
 #include "main_text.h"
+#include "mark_reg.h"
 #include "chars_cmds.h"
 #include "dial_box.h"
@@ -78,5 +79,5 @@ int tab_width = TAB_WIDTH;
 
 FCT (static int, GetNbLinesInPage, (Text *text, XFontStruct *font) );
-FCT (static void, Set_mode_internal, (Text *text, char *mode_name) );
+FCT (static void, Set_mode_internal, (Text *text, const char *mode_name) );
 
 void ie_WR_delete ( text ) Text *text; { f_delete ( text ); }
@@ -280,5 +281,5 @@ void LoadMode ( text )
 	mode = mode -> next;
     }    
-    str = (char *) SelectFromListBox ( "Modes" );
+    str = SelectFromListBox ();
 /*    str = (char *) GetStringFromDB ( "Mode name : ", False ); */
     
@@ -319,5 +320,5 @@ void NewMode ( text )
 {
     Mode *new_mode;
-    char *str;    
+    const char *str;    
     char c = '\007'; /* ^G */
     
@@ -327,5 +328,5 @@ void NewMode ( text )
     }
 
-    str = (char *) GetStringFromDB ( "New mode name : ", False );
+    str = GetStringFromDB ( "New mode name : ", False );
     if ( (str == 0) || (strncmp(str, &c, 1)) == 0 ) {
 	DisplayMessage ( text -> mwin, "Abort" );
@@ -462,5 +463,5 @@ void SetFontText ( display, text, font )
 XFontStruct *LoadFont ( dpy, str )
     Display *dpy;
-    char    *str;
+    const char    *str;
 {
     XFontStruct     *font;
@@ -490,5 +491,5 @@ void ChangeFont ( dpy, text, f )
     Display *dpy;
     Text *text;
-    char *f;
+    const char *f;
 {
     XFontStruct *font;
@@ -689,5 +690,5 @@ void SetTextModif ( text) 
 static void Set_mode_internal(text, mode_name)
     Text *text;
-    char *mode_name;
+    const char *mode_name;
 {
     if ( strcmp(text -> current_mode -> name, mode_name) != 0 ) {
--- main_text.h	2002-02-14 09:56:25.000000000 -0500
+++ main_text.h	2014-12-27 05:01:34.000000000 -0500
@@ -43,4 +43,5 @@
 
 #include <sys/param.h>
+#include <sys/types.h>
 
 #include "main_buffer.h"
@@ -70,5 +71,5 @@ typedef struct _TextResources {
  *	Toutes les infos sur le texte.
  */
-typedef struct _Text {
+struct _Text {
 	Window window;		/* La fenetre de texte */
 	Window w_parent;	/* La fenetre parent */
@@ -129,5 +130,5 @@ typedef struct _Text {
 	int ie_mark;
 	
-	int shell_id; /* Pour la connection eventuelle a un shell */
+	pid_t shell_id; /* Pour la connection eventuelle a un shell */
 	int p_shell [2]; /* Le pipes */
 	int p_xc [2];
@@ -137,9 +138,11 @@ typedef struct _Text {
 	ColorElement *last_ce;
 	Selection *selection;
-} Text;
+};
+
+typedef struct _Text Text;
 
 
 FCT (void, ChangeDir, (Text *text) );
-FCT (void, ChangeFont, (Display *dpy, Text *text, char *f) );
+FCT (void, ChangeFont, (Display *dpy, Text *text, const char *f) );
 FCT (void, ConfigTextAndScroll, (Text *text, int width, int height, int space) );
 FCT (void, DeleteText, (Display *dpy, Text *text) );
@@ -147,5 +150,5 @@ FCT (void, ExposeTextWindow, (Display *d
 FCT (void, InitTextRes, (Display *dpy, XFontStruct *font, unsigned long fg, unsigned long bg, unsigned long ts, unsigned long bs) );
 FCT (void, KillText, (Display *dpy, Text *text) );
-FCT (XFontStruct *, LoadFont, (Display *dpy, char *str) );
+FCT (XFontStruct *, LoadFont, (Display *dpy, const char *str) );
 FCT (void, LoadMode, (Text *text) );
 FCT (Text *, MakeTextWindow, (Display *dpy, Window parent, int x, int y) );
@@ -170,5 +173,5 @@ FCT (void, DoUndo, (Text *text) );
 FCT (void, DoUndoUndo, (Text *text) );
 FCT (void, ResetUndo, (Text *text) );
-FCT (void, StoreInUndo, (Text *text, char *s, char *sr, int len, int n, int type) );
+FCT (void, StoreInUndo, (Text *text, const char *s, const char *sr, int len, int n, int type) );
 FCT (void, SetLatexMode, (Text *text) );
 FCT (void, SetHtmlMode, (Text *text) );
@@ -179,9 +182,9 @@ FCT (void, SetEdirMode, (Text *text) );
 FCT (void, SetshellMode, (Text *text) );
 
-FCT (void, SetColorArea, (Text *text, int start, int end, char *colorname) );
+FCT (void, SetColorArea, (Text *text, int start, int end, const char *colorname) );
 FCT (void, UnColorArea, (Text *text, int start, int end) );
 FCT (void, DeleteColorList, (Text *text) );
 FCT (void, UpdateColorList, (Text *text, int nbytes) );
-FCT (void, ColorLineInPage, (Text *text,  int x, int y, int li, char *s, int n) );
+FCT (void, ColorLineInPage, (Text *text,  int x, int y, int li, const char *s, int n) );
 FCT (unsigned long, GetCursorColor, (Text *text) );
 
@@ -224,8 +227,3 @@ FCT (unsigned long, GetCursorColor, (Tex
 #define OPENFILES	2
 
-#endif /* _MAIN_TEXT_H_ */
-
-
-
-
-
+#endif /* _MAIN_TEXT_H_ */
\ No newline at end of file
--- man_box.c	2006-11-16 03:54:46.000000000 -0500
+++ man_box.c	2014-12-27 05:22:24.000000000 -0500
@@ -61,13 +61,14 @@
 #include "shadow.h"
 #include "bm_search.h"
+#include "chars_cmds.h"
 
 extern Display *dpy;
 MBox man_box;
 static  Atom man_del;
-static  fill_man = True;
+static  int fill_man = True;
 
-FCT (static void, LoadManText, () );
-FCT (static void, RefreshManTitleBox, () );
-FCT (static void, UnmapManBox, () );
+FCT (static void, LoadManText, (void) );
+FCT (static void, RefreshManTitleBox, (void) );
+FCT (static void, UnmapManBox, (void) );
 
 
@@ -239,5 +240,5 @@ void InitManBox ()
 void DisplayManBox ()
 {
-  static first_display = True;
+  static int first_display = True;
   
   XMapSubwindows ( dpy, man_box.ctr );
@@ -634,5 +635,4 @@ int ButtonManBox ( ev )
   }
   if ( ev -> window == man_box.man_text -> window) {
-    Time selection_time;
     int selection, ccontext=1;
     if (ccontext)
--- man_box.h	2001-07-08 11:40:16.000000000 -0400
+++ man_box.h	2014-12-27 05:21:12.000000000 -0500
@@ -89,7 +89,7 @@ typedef struct _MBox {
 FCT (int, ButtonManBox, ( XButtonEvent * ev ));
 FCT (void, ConfigManBox, (int width, int height) );
-FCT (void, DisplayManBox, () );
+FCT (void, DisplayManBox, (void) );
 FCT (int, ExposeManBox, (XEvent *ev) );
-FCT (void, InitManBox, () );
+FCT (void, InitManBox, (void) );
 FCT (int, KeyPressInManual, (XKeyEvent * ev ));
     
--- mode.c	2000-03-29 11:30:32.000000000 -0500
+++ mode.c	2014-12-27 04:47:10.000000000 -0500
@@ -80,8 +80,8 @@ Mode *m_default; 
 FCT (void, ie_WR_delete, (Text *text) ); 
 
-FCT (static Mode *, AllocMode, () );
+FCT (static Mode *, AllocMode, (void) );
 FCT (static void, ResetMode, (Mode *mode) );
 FCT (static void, SetDefaultModeValues, (Mode *mode) );
-FCT (static void, SetModeName, (Mode *mode, char *mode_name) );
+FCT (static void, SetModeName, (Mode *mode, const char *mode_name) );
 
 FCT (static void, ie_WR_setmark, (Text *text) );
@@ -127,8 +127,8 @@ FCT (static void, ie_WR_goto_line, (Text
 FCT (static void, ie_WR_eval_expression, (Text *text) );
 FCT (static void, ie_WR_list_open_file, (Text *text) );
-FCT (static void, ie_WR_str_return, (Text *text) );
-FCT (static void, ie_WR_str_tab, (Text *text) );
-FCT (static void, ie_WR_str_abort, (Text *text) );
-FCT (static void, ie_WR_str_previous, (Text *text) );
+FCT (static void, ie_WR_str_return, (void) );
+FCT (static void, ie_WR_str_tab, (void) );
+FCT (static void, ie_WR_str_abort, (void) );
+FCT (static void, ie_WR_str_previous, (void) );
 FCT (static void, ie_WR_shell_return, (Text *text) );
 FCT (static void, ie_WR_shell_CtrC, (Text *text) );
@@ -138,5 +138,5 @@ FCT (static void, ie_WR_yank, (Text *tex
 
 #if !HAVE_STRDUP
-extern FCT (char*, strdup, (char*) );
+extern FCT (char*, strdup, (const char*) );
 #endif
 
@@ -150,5 +150,5 @@ extern FCT (char*, strdup, (char*) );
 static Mode *AllocMode ()
 {
-  return (Mode *) malloc ((unsigned) sizeof (Mode));
+  return malloc (sizeof (Mode));
 }
 
@@ -254,5 +254,5 @@ static void ResetMode ( mode )
 */
 Mode *GetMode ( name )
-    char *name;
+    const char *name;
 {
     Mode *tmp = m_default;
@@ -281,5 +281,5 @@ Mode *GetMode ( name )
 */
 Mode *CreateNewMode ( mode_name )
-    char *mode_name;
+    const char *mode_name;
 {
     Mode *new_mode, *tmp = m_default;
@@ -323,14 +323,12 @@ Mode *CreateNewMode ( mode_name )
 static void SetModeName ( mode , mode_name )
     Mode *mode;
-    char *mode_name;
+    const char *mode_name;
 {
-    mode -> name = (char *) malloc ((unsigned) (strlen(mode_name) + 2));
+    mode->name = strdup(mode_name);
 
-    if ( mode -> name == 0 ) {
+    if (mode -> name == NULL) {
 	(void) fprintf ( stderr, "Malloc error\n" );
 	exit (1);
     }
-
-    (void) strcpy ( mode -> name, mode_name );
 }
 
@@ -345,5 +343,5 @@ static void SetModeName ( mode , mode_na
 void SetModeSuffixe ( mode, suffixes )
     Mode *mode;
-    char *suffixes;
+    const char *suffixes;
 {
     if ( suffixes == 0 ) {
@@ -370,5 +368,5 @@ void SetModeSuffixe ( mode, suffixes )
 void SetModeFont ( mode, font_name )
     Mode *mode;
-    char *font_name;
+    const char *font_name;
 {
     extern Display *dpy;
@@ -393,11 +391,11 @@ void SetModeFont ( mode, font_name )
 */
 Mode *SearchMode ( filename )
-    char *filename;
+    const char *filename;
 {
-    char *end_name;
+    const char *end_name;
     Mode *tmp = m_default;
     int trouve = False;
 
-    end_name = (char * ) strrchr ( filename, '.' );
+    end_name = strrchr ( filename, '.' );
     if ( end_name == 0 )
       return m_default;
@@ -485,8 +483,8 @@ static void ie_WR_list_open_file ( text 
 
 /* Les fonctions speciales pour le mini-buffer. */
-static void ie_WR_str_return ( text ) Text *text; { InputStrReturn (text);}
-static void ie_WR_str_tab ( text ) Text *text; { InputStrTab (text);}
-static void ie_WR_str_abort ( text ) Text *text; { InputStrAbort (text);}
-static void ie_WR_str_previous ( text ) Text *text; { InputStrPrevious (text);}
+static void ie_WR_str_return (void) { InputStrReturn ();}
+static void ie_WR_str_tab (void) { InputStrTab ();}
+static void ie_WR_str_abort (void) { InputStrAbort ();}
+static void ie_WR_str_previous (void) { InputStrPrevious ();}
 
 /* Les fonctions speciales pour le Shell */
@@ -499,5 +497,5 @@ static void ie_WR_shell_key ( text ) Tex
 typedef struct {
     void (* f) ();
-    char *s;
+    const char *s;
 } f2s;
 
@@ -564,5 +562,5 @@ f2s func_string [NB_BUILTIN_FUNC] = {
 */
 long GetFuncNameFromString ( s )
-    char *s;
+    const char *s;
 {
     int i = 0;
@@ -671,5 +669,5 @@ static void SetDefaultModeValues ( mode 
 
     {
-      unsigned code = Xk_Code((unsigned char *)"Right");
+      unsigned code = Xk_Code("Right");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -677,5 +675,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R12");
+      unsigned code = Xk_Code("R12");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -683,5 +681,5 @@ static void SetDefaultModeValues ( mode 
     }    
     {
-      unsigned code = Xk_Code((unsigned char *)"Left");
+      unsigned code = Xk_Code("Left");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -689,5 +687,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R10");
+      unsigned code = Xk_Code("R10");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -695,11 +693,11 @@ static void SetDefaultModeValues ( mode 
     }    
     {
-      unsigned code = Xk_Code((unsigned char *)"Up");
-      
+      unsigned code = Xk_Code("Up");
+ 
       mode -> key [code].type = BUILTIN_FUNC;
       mode -> key [code].func = ie_WR_cursor_up;
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R8");
+      unsigned code = Xk_Code("R8");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -707,5 +705,5 @@ static void SetDefaultModeValues ( mode 
     }    
     {
-      unsigned code = Xk_Code((unsigned char *)"Down");
+      unsigned code = Xk_Code("Down");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -713,5 +711,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R14");
+      unsigned code = Xk_Code("R14");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -719,5 +717,5 @@ static void SetDefaultModeValues ( mode 
     }    
     {
-      unsigned code = Xk_Code((unsigned char *)"Home");
+      unsigned code = Xk_Code("Home");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -725,5 +723,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R7");
+      unsigned code = Xk_Code("R7");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -731,5 +729,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"Next");
+      unsigned code = Xk_Code("Next");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -737,5 +735,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R15");
+      unsigned code = Xk_Code("R15");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -743,5 +741,5 @@ static void SetDefaultModeValues ( mode 
     }    
     {
-      unsigned code = Xk_Code((unsigned char *)"Prior");
+      unsigned code = Xk_Code("Prior");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -749,5 +747,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R9");
+      unsigned code = Xk_Code("R9");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -755,5 +753,5 @@ static void SetDefaultModeValues ( mode 
     }    
     {
-      unsigned code = Xk_Code((unsigned char *)"End");
+      unsigned code = Xk_Code("End");
       
       mode -> key [code].type = BUILTIN_FUNC;
@@ -761,5 +759,5 @@ static void SetDefaultModeValues ( mode 
     }
     {
-      unsigned code = Xk_Code((unsigned char *)"R13");
+      unsigned code = Xk_Code("R13");
       
       mode -> key [code].type = BUILTIN_FUNC;
--- mode.h	1998-10-11 08:33:51.000000000 -0400
+++ mode.h	2014-12-26 00:28:14.000000000 -0500
@@ -65,13 +65,13 @@ typedef struct _mode {
 } Mode;
 
-FCT (Mode *, CreateNewMode, (char *mode_name) );
+FCT (Mode *, CreateNewMode, (const char *mode_name) );
 
-FCT (long, GetFuncNameFromString, (char *s) );
+FCT (long, GetFuncNameFromString, (const char *s) );
 
-FCT (Mode *, GetMode, (char *name) );
-FCT (void, InitMode, () );
-FCT (Mode *, SearchMode, (char *filename) );
-FCT (void, SetModeFont, (Mode *mode, char *font_name) );
-FCT (void, SetModeSuffixe, (Mode *mode, char *suffixes) );
+FCT (Mode *, GetMode, (const char *name) );
+FCT (void, InitMode, (void) );
+FCT (Mode *, SearchMode, (const char *filename) );
+FCT (void, SetModeFont, (Mode *mode, const char *font_name) );
+FCT (void, SetModeSuffixe, (Mode *mode, const char *suffixes) );
 
 #endif /* _MODE_H_ */
